package space.kklochko.jdbc_hospital_example.cli.commands;

import lombok.AllArgsConstructor;
import lombok.Data;
import space.kklochko.jdbc_hospital_example.db.repositories.AbstractRepository;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;

@AllArgsConstructor
@Data
public class CommandEntities<T> {
    private AbstractRepository<T> repository;
    private Method method;

    public ArrayList<T> run() {
        try {
            return (ArrayList<T>) method.invoke(getRepository());
        } catch (InvocationTargetException e) {
            System.err.println(e.getMessage());
            throw new RuntimeException(e);
        } catch (IllegalAccessException e) {
            System.err.println(e.getMessage());
            throw new RuntimeException(e);
        }
    };
}
